package hr.fer.zemris.projekt.database;

import hr.fer.zemris.projekt.database.sqliteimpl.DatabaseSQLiteImpl;

/**
 * Razred u čijoj je nadležnosti odabir implementacije baze podataka. Ostatku aplikacije nudi
 * implementaciju baze podataka.
 * 
 * @author
 * 
 */
public final class DatabaseProvider {

    /** Baza podataka */
    private static final Database database;

    /** Odabir implementacije baze podataka */
    static {
	database = new DatabaseSQLiteImpl();
    }

    /** Dohvaća implementaciju baze podataka */
    public static Database getDatabase() {
	return database;
    }

}
