package hr.fer.zemris.projekt.swing;

import hr.fer.zemris.projekt.util.Config;

import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 * Razred predstavlja grafičko sučelje tj. prozor s općim informacijama o programu.
 * 
 * @author
 * 
 */
public class AboutWindow extends JFrame {

    /** Serijski broj */
    private static final long serialVersionUID = 1L;

    /** True ako je ovaj prozor otvoren, false ako nije */
    private static boolean windowExists = false;

    /**
     * Konstruktor AboutWindow. Poziva iniciranje grafičkog sučelja tj. prozora kojeg predstavlja
     * razred.
     */
    public AboutWindow() {
	if (windowExists) {
	    return;
	}
	windowExists = true;

	initGUI();
    }

    /**
     * Inicira i pokreće grafičko sučelje.
     */
    private void initGUI() {
	setTitle(Config.aboutWindowTitle);
	setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);

	Container c = getContentPane();
	c.setLayout(new BoxLayout(c, BoxLayout.Y_AXIS));
	c.setBackground(Color.white);
	final JLabel funLabel = new JLabel();
	c.add(funLabel);
	funLabel.setFont(new Font("Monospace", Font.PLAIN, 10));
	JLabel l = new JLabel(Config.aboutWindowText);
	l.setBackground(Color.white);
	c.add(l);

	final Timer t = new Timer(true);
	t.scheduleAtFixedRate(new TimerTask() {
	    private char a = ' ';
	    private char b = '.';
	    private char[] c = { b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b,
		    b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b,
		    b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b,
		    b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b, b,
		    b, b, b, b, b, b, b, b };
	    private int i = 0;

	    @Override
	    public void run() {
		if (i >= c.length - 1) {
		    i = 0;
		}
		if (c[i] == b) {
		    c[i] = a;
		} else {
		    c[i] = b;
		}
		if (c[c.length - 1 - i] == b) {
		    c[c.length - 1 - i] = a;
		} else {
		    c[c.length - 1 - i] = b;
		}
		++i;
		funLabel.setText(String.valueOf(c));
	    }
	}, 0, 35);

	addWindowListener(new WindowAdapter() {
	    @Override
	    public void windowClosing(WindowEvent e) {
		dispose();
		windowExists = false;
		t.cancel();
	    }
	});

	pack();
	setResizable(false);
	setLocationRelativeTo(null);
	setVisible(true);
    }
}
