package hr.fer.zemris.projekt.swing;

import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableCellRenderer;

/**
 * Razred predstavlja poboljšanu implementaciju JTable razreda. Nudi lakše podešavanje pozicije
 * teksta u ćelijama tablice.
 * 
 * @author
 * 
 */
public class MyTable extends JTable {

    /** Serijski broj */
    private static final long serialVersionUID = 1L;

    /** Vrijednost koja identificira poziciju teksta u ćelijama tablice (iz SwingConstants) */
    private int horizontalAlignment;

    /**
     * Konstruktor MyTable.
     * 
     * @param horizontalAlignment vrijednost koja identificira poziciju teksta u ćelijama tablice
     *            (iz SwingConstants)
     */
    public MyTable(int horizontalAlignment) {
	this.horizontalAlignment = horizontalAlignment;
    }

    /** Prikazivač/ctrač ćelija */
    private TableCellRenderer renderer = new DefaultTableCellRenderer() {
	private static final long serialVersionUID = 1L;

	@Override
	public Component getTableCellRendererComponent(JTable table, Object value,
		boolean isSelected, boolean hasFocus, int row, int column) {
	    JLabel renderedLabel = (JLabel) super.getTableCellRendererComponent(table, value,
		    isSelected, hasFocus, row, column);
	    renderedLabel.setHorizontalAlignment(horizontalAlignment);
	    return renderedLabel;
	}
    };

    /**
     * Dohvaća prikazivač/crtač ćelija
     */
    public TableCellRenderer getCellRenderer(int row, int column) {
	return renderer;
    }

}